<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Shipping Restriction Restricted Products by Amasty
 */

namespace Amasty\ShiprestrictionRestrictedProducts\Model\Message\MessageBuilderProcessors;

use Amasty\Shiprestriction\Model\Message\MessageBuilderProcessors\MessageBuilderProcessorInterface;
use Amasty\Shiprestriction\Model\ProductRegistry;

class LastRestrictedProductProcessor implements MessageBuilderProcessorInterface
{
    /**
     * @var ProductRegistry
     */
    private $productRegistry;

    public function __construct(
        ProductRegistry $productRegistry
    ) {
        $this->productRegistry = $productRegistry;
    }

    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function process(string $message): string
    {
        $restrictedProducts = $this->productRegistry->getRestrictedProducts();
        $lastRestrictedProducts = $restrictedProducts ? end($restrictedProducts) : "";

        return str_replace('{last-restricted-product}', $lastRestrictedProducts, $message);
    }
}
